#!/usr/bin/env python
#
#  LGPL - don't steal, don't sue
#
'tests the Browser test runner'

import unittest, sys, os
from Debug import db, removeForcedRecursive


class DebugTestCase(unittest.TestCase):
    "Tests the manual debugging goodies"

    def write(self, lines):
        self.myOutput += lines
        
    def test_db(self):
        self.myOutput = ''
        x = 10
        waz = sys.stderr
        sys.stderr = self
        db (x)
        y = 11
        db (x,y)
        db (x,(y))
        sys.stderr = waz
        
        exp = 'test_Debug.py:22: x = 10\n' + \
              'test_Debug.py:24: x,y = (10,11)\n' + \
              'test_Debug.py:25: x,(y) = (10,11)\n'

        #db(got)  #  the irony is not lost on me
        #db(exp)
        self.assertEquals(self.myOutput, exp)

    def test_removeForcedRecursive(self):
        open('removeMe.txt', 'w').write('yo')
        removeForcedRecursive('removeMe.txt')
        self.assert_(not os.path.exists('removeMe.txt'))
        removeForcedRecursive('crunchyFrog')
        os.mkdir('crunchyFrog')
        open('crunchyFrog/removeMe.txt', 'w').write('yo')
        removeForcedRecursive('crunchyFrog')
        self.assert_(not os.path.exists('crunchyFrog'))

        
